#include "LCD.h"
#include<msp430f5438.h>

unsigned int LAY1_X=0;
unsigned int LAY1_Y=0;
unsigned int LAY2_X=0;
unsigned int LAY2_Y=0;

const unsigned char NUMBER[13][10]={
    {0x18,0x24,0x42,0x42,0x42,0x42,0x42,0x42,0x24,0x18},//0
    {0x10,0x70,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x7C},//1
    {0x3C,0x42,0x42,0x02,0x04,0x08,0x10,0x20,0x42,0x7E},//2
    {0x3C,0x42,0x42,0x04,0x18,0x04,0x02,0x42,0x42,0x3C},//3
    {0x08,0x08,0x18,0x28,0x48,0x48,0x7E,0x08,0x08,0x1E},//4
    {0x7E,0x40,0x40,0x5C,0x62,0x02,0x02,0x42,0x42,0x3C},//5
    {0x1C,0x24,0x40,0x40,0x5C,0x62,0x42,0x42,0x42,0x3C},//6
    {0x7E,0x44,0x44,0x08,0x08,0x10,0x10,0x10,0x10,0x10},//7
    {0x3C,0x42,0x42,0x42,0x3C,0x24,0x42,0x42,0x42,0x3C},//8
    {0x38,0x44,0x42,0x42,0x46,0x3A,0x02,0x02,0x24,0x38},//9
    {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},//' '
    {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0c,0x0c},//'.'
    {0x00,0x00,0x00,0x00,0x7E,0x00,0x00,0x00,0x00,0x00} //'-'
};


/********************************************************************
* ƣdelay()
* ܣͨʱ
* ڲi
********************************************************************/
void delay(unsigned int i)
{
	unsigned int x;
	for(x=0;x<i;x++);
}

/********************************************************************
* ƣsend_com()
* ܣ320240
* ڲdat
********************************************************************/
void send_com(unsigned char dat)
{
    DATA_DIR =0XFF;
    CS_L;
    A0_H;
    WR_L;
    //delay(1);
    DATA_OUT=dat;
    //delay(1);
    WR_H;
    CS_H;
    //delay(2);
	
}

/********************************************************************
* ƣsend_data()
* ܣ320240
* ڲdat
********************************************************************/
void send_data(unsigned char dat)
{
    DATA_DIR =0XFF;
    CS_L;
    A0_L;
    WR_L;
    //delay(1);
    DATA_OUT=dat;
    //delay(1);
    WR_H;
    CS_H;
    //delay(2);
}

/********************************************************************
* ƣread_data()
* ܣ320240
* ڲdat
********************************************************************/
unsigned char read_data(void)
{
    unsigned char dat;
    DATA_DIR &=0X00;
    CS_L;
    A0_H;
    WR_H;
    RD_L;
    delay(1);
    dat=DATA_IN;
    RD_H;
    delay(1);
    CS_H;
    delay(2);
    return(dat);
}

/******************************************************************
*ƣmoveto()
*ܣǰƶlayerͼ(x,y)
*ڲlayer,x,y
******************************************************************/
void moveto(char layer,unsigned int x,unsigned int y)
{
    unsigned int k;
    unsigned char m,n;
    unsigned int offset;
    if(layer==1) offset=0;
    else if(layer==2) offset=9600;
    else return;
    if((x>319)||(y>239))  return;
    k=((40*y)+(x>>3))+offset;
    m=k&0x00ff;
    n=k>>8;
    send_com(0x46);
    send_data(m);
    send_data(n);
    
    if(layer==1)
    {
	LAY1_X=x;
	LAY1_Y=y;
    }
    else
    {
	LAY2_X=x;
	LAY2_Y=y;
    }
}


/******************************************************************
*ƣmoverel()
*ܣǰƶlayerͼ(LAY+dx,LAY+dy)
*ڲlayer,x,y
******************************************************************/
void moverel(char layer,int dx,int dy)
{
    unsigned int tempx,tempy;
    if(layer==1)
    {
	tempx=LAY1_X+dx;
	tempy=LAY1_Y+dy;
	if(LAY1_Y>239) return;
	if(LAY1_X>319) return;
	moveto(layer,tempx,tempy);
    }
    else if(layer==2)
    {
	tempx=LAY2_X+dx;
	tempy=LAY2_Y+dy;
	if(LAY2_Y>239) return;
	if(LAY2_X>319) return;
	moveto(layer,tempx,tempy);
    }
    else return;
}

/********************************************************************
*ƣfull_clr()
*ܣһ
*ڲlayer,ѡͼ
********************************************************************/
void full_clr(char layer)
{
    unsigned int i=9600;
    moveto(layer,0,0);
    send_com(W_DATA);
    while(i--)
    {	
	send_data(LCD_CLR);
    }
}

/********************************************************************
*ƣclear()
*ܣ(x,y)һ
*ڲlayer,x,y,wid,hei
********************************************************************/
void clear(char layer,unsigned int x,unsigned int y,unsigned int wid,unsigned int hei)
{
    unsigned int i,j=0,k;
    for(k=0;k<hei;k++)
    {
	moveto(layer,x,y+k);
	send_com(0x42);
	for(i=0;i<wid/8;i++)
	{
	    send_data(LCD_CLR);
	    j++;
	}
    }
}

/********************************************************************
* :LCD_init() 
* :lcd ʼ  ˫ͼ
********************************************************************/
void LCD_init(void)
{
    DATA_DIR=0xff;
    CONTROL_DIR=0x3f;
    RST_L;
    delay(3000);
    RST_H;
    delay(3000);

    send_com(0x40);    //ʼ
    send_data(0x30);
    send_data(0x87);
    send_data(0x07);
    send_data(0x27);
    send_data(0x34);
    send_data(0xef);
    send_data(0x28);
    send_data(0x00);
    
    send_com(0x44);      //ʾ
    send_data(0x00);    // ͼһʼλ
    send_data(0x00);    //ͼһʼλ
    send_data(0xf0);    // ͼһsize
    send_data(0x80);    // ͼʼλ    b0
    send_data(0x25);//1200  ͼʼλ   04
    send_data(0xf0);   //ͼsize
    send_data(0x00);   // ͼʼλ     30
    send_data(0x4B);//9600 // ͼʼλ  2a
    send_data(0xb0);  // ͼʼλ
    send_data(0x4f);  // ͼʼλ
    
    send_com(0x5a);   //λ   
    send_data(0x00);
    send_com(0x5b);   //ʾϳ  
    send_data(0x0C);  
    send_com(0x58);  //ʾ״̬
    send_data(0xfe);//fe
    
    
    full_clr(1);                  //һ
    full_clr(2);
    send_com(0x46);  //ָ
    send_data(0x00);
    send_data(0x00);
    
    send_com(0x5d);    //״
    send_data(0x04);
    send_data(0x06);
    send_com(0x59);    //ʾ״̬
    send_data(0x16);
    
    //send_com(0x4f);//ƶ[ƶ
            
}

void pixel_rev(char layer,unsigned int x,unsigned int y)
{
	unsigned int i,dot=0x80;
    if(layer>2) return;
    if(x>319) return;
    if(y>239) return;
    i=x%8;
    dot=dot>>i;
    moveto(layer,x,y);
    send_com(R_DATA);
    i=read_data();
    dot=dot^i;
    moveto(layer,x,y);
    send_com(W_DATA);
    send_data(dot);
}

void highlight(char layer,unsigned int x,unsigned int y,unsigned int wid,unsigned hei)
{
	int i,j;
	for(i=0;i<hei;i++)
	{
		for(j=0;j<wid;j++)
		{
			pixel_rev(layer,x+j,y+i);
		}
	}
}


/********************************************************************
*ƣput_pixel()
*ܣڵlayer(x,y)
*ڲlayer,x,y
********************************************************************/
void put_pixel(char layer,unsigned int x,unsigned int y)
{
    unsigned int i,dot=0x80;
    if(layer>2) return;
    if(x>319) return;
    if(y>239) return;
    i=x%8;
    dot=dot>>i;
    moveto(layer,x,y);
    send_com(R_DATA);
    i=read_data();
    dot=dot|i;
    moveto(layer,x,y);
    send_com(W_DATA);
    send_data(dot);
    moveto(layer,x,y);
}

/********************************************************************
*ƣline()
*ܣڵlayer㻭һ(x,y)(x1,y1)ֱ
*ڲlayer,x,y,x1,y1
********************************************************************/
void line(char layer,unsigned int x,unsigned int y,unsigned int x1,unsigned int y1)
{
    if(layer>2) return;
    if(x>319||x1>319) return ;
    if(y>239||y1>239) return ;
    int i,j;
    float k;
    if(x==x1)
    {
	if(y1>y)
	{
	    for(i=y;i<=y1;i++)
	    {
		put_pixel(layer,x,i);
	    }
	}
	else
	{
	    for(i=y1;i<=y;i++)
	    {
		put_pixel(layer,x,i);
	    }
	}
    }
    else
    {
	float m=(float)y1-y;
	float n=(float)x1-x;
	k=m/n;
	if(x1>x)
	{
	    for(i=x;i<=x1;i++)
	    {
		j=(int)(k*(i-x)+y);
		put_pixel(layer,i,j);
	    }
	}
	else
	{
	    for(i=x1;i<=x;i++)
	    {
		j=(int)(k*(i-x1)+y1);
		put_pixel(layer,i,j);
	    }
	}
    }
    moveto(layer,x1,y1);
}

/********************************************************************
*ƣlineto()
*ܣڵlayer㵱ǰ괦һ(x,y)ֱ
*ڲlayer,x,y,x,y
********************************************************************/
void lineto(char layer,unsigned int x,unsigned int y)
{
    if(x>319||y>239) return ;
    if(layer==1)
    {
	line(layer,LAY1_X,LAY1_Y,x,y);
	moveto(layer,x,y);
    }
    else if(layer==2)
    {
	line(layer,LAY2_X,LAY2_Y,x,y);
	moveto(layer,x,y);
    }
    else return;
}

/********************************************************************
*ƣrectangle()
*ܣڵlayer㻭һ
*ڲ
layer
left:x
top:ϲy
right:Ҳx
bottom:²y
********************************************************************/
void rectangle(char layer,unsigned int left,unsigned int top,unsigned int right,unsigned int bottom)
{
    moveto(layer,left,top);
    lineto(layer,right,top);
    lineto(layer,right,bottom);
    lineto(layer,left,bottom);
    lineto(layer,left,top);
    moveto(layer,left,top);
}

/********************************************************************
*ƣint_str()
*ܣתַ
*ڲbuffer[],num
*ڲ: ַ
********************************************************************/
int int_str(char buf[],long num)
{
    int j,flag=0;
    if(num<0)
    {
	flag=1;
	num=-num;
    }
    j=0;
    while(num>0)
    {
	buf[j++]=num%10+'0';
	num=num/10;
    }
    if(j==0)
    {
	buf[0]='0';
	j=1;
    }
    if(flag==1)
    {
	buf[j++]='-';
    }
    return j;
}

/********************************************************************
*ƣfloat_str()
*ܣתַ
*ڲbuffer[],num,n
*ڲ: ַ
********************************************************************/
int float_str(char buf[],int n,float num)
{
    int j,temp;
    
    buf[0]='.';
    j=0;
    while(j<n-1)
    {
	j++;
	num=num*10.0;
	temp=(int)num;
	num=num-temp;
	buf[j]=temp+'0';
    }
    num=num+0.5;
    j=n-1;
    buf[j]+=(int)num;
    while(buf[j]==0)
    {
	j--;
    }
    return j+1;
}
	


/********************************************************************
*ƣwrite_int()
*ܣڵlayer(x,y)д
*ڲlayer,x,y,num
********************************************************************/
void write_int(char layer,unsigned int x,unsigned char y,long num)
{
    int i,j,sel,m;
    char buffer[20];
    j=int_str(buffer,num);
    for(i=j-1;i>=0;i--)
    {
	if(buffer[i]=='-') sel=12;
	else sel=buffer[i]-'0';
	for(m=0;m<10;m++)
	{
		moveto(layer,x+(j-1-i)*8,y+m);
		send_com(W_DATA);
		send_data(NUMBER[sel][m]);
	}
    }
}


/********************************************************************
*ƣwrite_real()
*ܣڵlayer(x,y)дʵС3λ
*ڲlayer,x,y,num
********************************************************************/
void write_real(char layer,unsigned int x,unsigned char y,float num,int n)
{
    int i,sel,m,len1,len2;
    char buf1[10],buf2[10];
    long temp;
    if(num<0)
    {
	num=-num;
	temp=(long)num;
	num=num-temp;
	temp=-temp;
    }
    else 
    {
	temp=(long)num;
	num=num-temp;
    }
    len1=int_str(buf1,temp);
    len2=float_str(buf2,n+1,num);
    for(i=len1-1;i>=0;i--)
    {
	if(buf1[i]=='-') sel=12;
	else sel=buf1[i]-'0';
	for(m=0;m<10;m++)
	{
	    moveto(layer,x+(len1-1-i)*8,y+m);
	    send_com(W_DATA);
	    send_data(NUMBER[sel][m]);
	}
    }
    for(i=0;i<len2;i++)
    {
	if(buf2[i]=='.') sel=11;
	else sel=buf2[i]-'0';
	for(m=0;m<10;m++)
	{
	    moveto(layer,x+(i+len1)*8,y+m);
	    send_com(W_DATA);
	    send_data(NUMBER[sel][m]);
	}
    }
}

/********************************************************************
*ƣdraw()
*ܣڵlayer(x,y)ͼ
*ڲlayer,x,y,w,h,pic[]
********************************************************************/
void draw(char layer,unsigned int x,unsigned char y,unsigned int w,unsigned char h,const unsigned char *pic)
{
    unsigned int i,j=0,k;
    for(k=0;k<h;k++)
    {
	moveto(layer,x,y+k);
	send_com(0x42);
	for(i=0;i<w/8;i++)
	{
	    send_data(pic[j]);
	    j++;
	}
    }
}


/********************************************************************
*ƣdraw()
*ܣڵlayer(x,y)ͼ
*ڲlayer,x,y,w,h,pic[]
********************************************************************/
void draw_picture(char layer,const unsigned char *pic)
{
    unsigned int i;
    moveto(layer,0,0);
    send_com(0x42);
    for(i=0;i<9600;i++)
    {	send_data(pic[i]);
    }
}