#ifndef LCD_H
#define LCD_H

extern unsigned int LAY1_X;
extern unsigned int LAY1_Y;
extern unsigned int LAY2_X;
extern unsigned int LAY2_Y;
extern const unsigned char NUMBER[][10];

#define DATA_DIR     P4DIR
#define DATA_OUT     P4OUT
#define DATA_IN      P4IN
#define CONTROL_DIR  P3DIR
#define CONTROL_OUT  P3OUT

#define WR_H  CONTROL_OUT |=  BIT0
#define WR_L  CONTROL_OUT &= ~BIT0
#define RD_H  CONTROL_OUT |=  BIT1
#define RD_L  CONTROL_OUT &= ~BIT1
#define CS_H  CONTROL_OUT |=  BIT2
#define CS_L  CONTROL_OUT &= ~BIT2
#define A0_H  CONTROL_OUT |=  BIT3
#define A0_L  CONTROL_OUT &= ~BIT3
#define RST_H CONTROL_OUT |=  BIT4
#define RST_L CONTROL_OUT &= ~BIT4

#define W_DATA 0X42
#define R_DATA 0X43
#define LCD_CLR 0X00

void delay(unsigned int i);	//ʱ
void send_com(unsigned char dat);	//д
void send_data(unsigned char dat);	//д
unsigned char read_data(void);

void LCD_init(void);	//LCDʼ
void full_clr(char layer);	//ͼlayer
void clear(char layer,unsigned int x,unsigned int y,unsigned int wid,unsigned int hei);//
void pixel_rev(char layer,unsigned int x,unsigned int y);
void highlight(char layer,unsigned int x,unsigned int y,unsigned int wid,unsigned int hei);

void moveto(char layer,unsigned int x,unsigned int y);	//ƶLAYER(x,y)
void moverel(char layer,int dx,int dy);//ƶ(LAY_X+dx,LAY_Y+dy)
void draw_picture(char layer,const unsigned char *pic);	//ͼlayerͼ
void draw(char layer,unsigned int x,unsigned char y,unsigned int w,unsigned char h,const unsigned char *pic);	//ͼlayerͼ
void write_int(char layer,unsigned int x,unsigned char y,long num);//д
void write_real(char layer,unsigned int x,unsigned char y,float num,int n);//д
int int_str(char buf[],long num);//תַ
int float_str(char buf[],int n,float num);//תַ
void put_pixel(char layer,unsigned int x,unsigned int y);//
void line(char layer,unsigned int x,unsigned int y,unsigned int x1,unsigned int y1);	//ֱ
void lineto(char layer,unsigned int x,unsigned int y);	//ֱ
void rectangle(char layer,unsigned int left,unsigned int top,unsigned int right,unsigned int bottom); //


#endif
